import { UseActionHandlerHookData } from './useAsyncHandler';
export declare type FetchAction<DataResult> = Omit<UseActionHandlerHookData<DataResult>, 'onAction'> & {
    tries: number;
};
declare function useAsyncFetch<DataResult>(onActionFn: () => Promise<DataResult>, options?: {
    maxTries?: number;
    timeoutBeforeRetry?: number;
}): FetchAction<DataResult>;
export default useAsyncFetch;
