import { UseErrorOptions } from './useError';
export interface UseActionHandlerOptions extends UseErrorOptions {
    isRetryAllowed?: boolean;
    strict?: boolean;
}
interface UseActionHandlerHookBase {
    reset(): void;
    error: string;
    isLoading: boolean;
}
export declare type AsyncAction<ActionResult, ActionParams = undefined> = {
    onAction: ActionParams extends undefined ? () => Promise<ActionResult> : (params: ActionParams) => Promise<ActionResult>;
} & UseActionHandlerHookData<ActionResult>;
export declare type UseActionHandlerHookData<DataResult> = ({
    isDone: false;
    data: null;
} & UseActionHandlerHookBase) | ({
    isDone: true;
    data: DataResult;
} & UseActionHandlerHookBase);
declare function useAsyncHandler<ActionResult>(onAction: () => Promise<ActionResult>, options?: UseActionHandlerOptions): {
    execute: () => Promise<ActionResult>;
} & UseActionHandlerHookData<ActionResult>;
declare function useAsyncHandler<ActionResult, Param>(onAction: (param: Param) => Promise<ActionResult>, options?: UseActionHandlerOptions): {
    execute: typeof onAction;
} & UseActionHandlerHookData<ActionResult>;
export default useAsyncHandler;
